// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

#include "GPR_ShootChance.h"
#include "Locations.h"
#include "Miner.h"
#include "EntityNames.h"
#include <iostream>
#include "Teste.h"
using std::cout;

/////////////////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "role_side_forward.h"

#include "bhv_chain_action.h"
#include "bhv_basic_offensive_kick.h"
#include "bhv_basic_move.h"

#include <rcsc/player/player_agent.h>
#include <rcsc/player/debug_client.h>

#include <rcsc/common/logger.h>

#include "strategy.h"
#include <rcsc/formation/formation.h>
#include <rcsc/player/intercept_table.h>
#include <rcsc/common/server_param.h>


using namespace rcsc;

const std::string RoleSideForward::NAME( "SideForward" );

/*-------------------------------------------------------------------*/
/*!

 */
namespace {
rcss::RegHolder role = SoccerRole::creators().autoReg( &RoleSideForward::create,
                                                       RoleSideForward::NAME );
}

/*-------------------------------------------------------------------*/
/*!

 */
bool
RoleSideForward::execute( PlayerAgent * agent )
{
    bool kickable = agent->world().self().isKickable();
    if ( agent->world().existKickableTeammate()
         && agent->world().teammatesFromBall().front()->distFromBall()
         < agent->world().ball().distFromSelf() )
    {
        kickable = false;
    }

    if ( kickable )
    {
        doKick( agent );
    }
    else
    {
        doMove( agent );
    }

    return true;
}

/*-------------------------------------------------------------------*/
/*!

 */
void
RoleSideForward::doKick( PlayerAgent * agent )
{
  switch ( Strategy::get_ball_area( agent->world().ball().pos() ) ) {
   // case Strategy::BA_CrossBlock:
	//Bhv_BasicOffensiveKick().execute( agent );break;    
   //case Strategy::BA_Stopper:
	//Bhv_BasicOffensiveKick().execute( agent );break;
   //case Strategy::BA_Danger:
    //Bhv_BasicOffensiveKick().execute( agent );break;
   //case Strategy::BA_DribbleBlock:
   	//Bhv_BasicOffensiveKick().execute( agent );break;
   //case Strategy::BA_DefMidField:
   	//Bhv_BasicOffensiveKick().execute( agent );break;
   //case Strategy::BA_DribbleAttack:
    //Bhv_BasicOffensiveKick().execute( agent );break;
   
    case Strategy::BA_OffMidField:
      // cout << "OffMidField"<< "\n";
      for(int i = 0 ; i < 3 ; i ++ ) {
	     miner.Update(agent, 7);
      } 
      break;

  //case Strategy::BA_Cross:
   //    cout << "Cross"<< "\n";
   //    for(int i = 0 ; i < 3 ; i ++ ) {
   //      miner.Update(agent,8);
   //     } break;

    case Strategy::BA_ShootChance:
      // cout << "ShootChance"<< "\n";
      for(int i = 0 ; i < 3 ; i ++ ) {
         miner.Update(agent,9);
      } 
      break;
		
    default:
    if ( Bhv_ChainAction().execute( agent ) )
    {
        dlog.addText( Logger::TEAM,
                      __FILE__": (execute) do chain action" );
        agent->debugClient().addMessage( "ChainAction" );
        return;
    }

    Bhv_BasicOffensiveKick().execute( agent );
     break;
    }  
}

/*-------------------------------------------------------------------*/
/*!

 */
void
RoleSideForward::doMove( PlayerAgent * agent )
{
    Bhv_BasicMove().execute( agent );
}
